From 2bf7435bf752dfc5af43158eee3b777b7e38c121 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Fri, 1 Dec 2023 11:40:16 +0100
Subject: [PATCH 31/54] feat: isolate info dialog into module

---
 lact-gui/src/app/dialogs.rs                   | 28 +++++++
 lact-gui/src/app/mod.rs                       | 78 ++++++++-----------
 lact-gui/src/app/root_stack/mod.rs            | 35 +++++++--
 .../src/app/root_stack/thermals_page/mod.rs   | 36 +++++----
 4 files changed, 109 insertions(+), 68 deletions(-)
 create mode 100644 lact-gui/src/app/dialogs.rs

diff --git a/lact-gui/src/app/dialogs.rs b/lact-gui/src/app/dialogs.rs
new file mode 100644
index 00000000..2cad3e3d
--- /dev/null
+++ b/lact-gui/src/app/dialogs.rs
@@ -0,0 +1,28 @@
+use gtk::prelude::*;
+use libadwaita::prelude::MessageDialogExt;
+use tracing::warn;
+
+#[macro_export]
+macro_rules! info_dialog {
+    ($parent:expr, $heading:expr, $body:expr, $response_id:expr, $response_txt:expr) => {{
+        let diag = libadwaita::MessageDialog::builder()
+            .heading($heading)
+            .body($body)
+            .modal(true)
+            .transient_for($parent)
+            .build();
+
+        diag.add_response($response_id, $response_txt);
+
+        diag.present();
+
+        diag
+    }};
+}
+
+pub fn show_error(parent: &impl IsA<gtk::Window>, err: anyhow::Error) {
+    let text = format!("{err:?}");
+    warn!("{}", text.trim());
+
+    info_dialog!(parent, "Error", &text, "close", "_Close");
+}
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index fc5fa145..5266982a 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -1,4 +1,5 @@
 mod apply_box;
+mod dialogs;
 mod gpu_selector;
 mod headerbar;
 mod info_row;
@@ -7,7 +8,8 @@ mod root_stack;
 
 use self::apply_box::ApplyBox;
 use self::headerbar::Headerbar;
-use crate::{APP_ID, GUI_VERSION};
+use crate::app::dialogs::show_error;
+use crate::{info_dialog, APP_ID, GUI_VERSION};
 use anyhow::{anyhow, Context};
 use glib::clone;
 use gpu_selector::GpuSelector;
@@ -61,7 +63,7 @@ impl App {
             show_error(&window, err);
         }
 
-        let root_stack = RootStack::new(window.clone(), system_info, daemon_client.embedded);
+        let root_stack = RootStack::new(&window, system_info, daemon_client.embedded);
 
         let root_view = libadwaita::ToolbarView::new();
 
@@ -189,21 +191,17 @@ impl App {
                     hbox.append(&enable_label);
                     hbox.append(&copy_btn);
 
-                    let diag = libadwaita::MessageDialog::builder()
-                        .title("Daemon info")
-                        .heading("Could not connect to daemon")
-                        .body(format!("Running in embedded mode.\n\
+                    let diag = info_dialog!(
+                        &app.window,
+                        "Could not connect to daemon",
+                        format!("Running in embedded mode.\n\
                             Please make sure the lactd service is running.\n\
                             Using embedded mode, you will not be able to change any settings.\n\n\
                             {error_text}\
-                            To enable the daemon, run the following command:"))
-                        .extra_child(&hbox)
-                        .modal(true)
-                        .transient_for(&app.window)
-                        .build();
-
-                    diag.add_response("close", "_Close");
-                    diag.present();
+                            To enable the daemon, run the following command:"),
+                        "close",
+                        "_Close");
+                    diag.set_extra_child(Some(&hbox));
                 }
             }));
 
@@ -493,25 +491,28 @@ impl App {
         dialog.set_response_appearance(res_cancel, libadwaita::ResponseAppearance::Destructive);
         dialog.set_response_appearance(res_ok, libadwaita::ResponseAppearance::Suggested);
 
-        dialog.connect_response(None, clone!(@strong self as app => move |_, response| {
-            if response == res_ok {
-                match app.daemon_client.enable_overdrive().and_then(|buffer| buffer.inner()) {
-                    Ok(_) => {
-                        let success_dialog = libadwaita::MessageDialog::builder()
-                            .heading("Success")
-                            .body("Overclocking successfully enabled. A system reboot is required to apply the changes")
-                            .modal(true)
-                            .transient_for(&app.window)
-                            .build();
-                        success_dialog.add_response("ok", "_Ok");
-                        success_dialog.present();
-                    }
-                    Err(err) => {
-                        show_error(&app.window, err);
+        dialog.connect_response(
+            None,
+            clone!(@strong self as app => move |_, response| {
+                if response == res_ok {
+                    match app.daemon_client.enable_overdrive().and_then(|buffer| buffer.inner()) {
+                        Ok(_) => {
+                            info_dialog!(
+                                &app.window,
+                                "Success",
+                                concat!(
+                                    "Overclocking successfully enabled. ",
+                                    "A system reboot is required to apply the changes"),
+                                "ok",
+                                "_Ok");
+                        }
+                        Err(err) => {
+                            show_error(&app.window, err);
+                        }
                     }
                 }
-            }
-        }));
+            }),
+        );
 
         dialog.present();
     }
@@ -583,21 +584,6 @@ enum GuiUpdateMsg {
     GpuStats(DeviceStats),
 }
 
-fn show_error(parent: &libadwaita::ApplicationWindow, err: anyhow::Error) {
-    let text = format!("{err:?}");
-    warn!("{}", text.trim());
-    let diag = libadwaita::MessageDialog::builder()
-        .heading("Error")
-        .body(&text)
-        .modal(true)
-        .transient_for(parent)
-        .build();
-
-    diag.add_response("close", "_Close");
-
-    diag.present();
-}
-
 fn confirmation_text(seconds_left: u64) -> String {
     format!("Do you want to keep the new settings? (Reverting in {seconds_left} seconds)")
 }
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 00ee7b2a..68084723 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -21,26 +21,49 @@ pub struct RootStack {
 
 impl RootStack {
     pub fn new(
-        root_win: libadwaita::ApplicationWindow,
+        root_win: &impl IsA<Window>,
         system_info: SystemInfo,
         embedded_daemon: bool,
     ) -> Self {
-        let container = libadwaita::ViewStack::builder().vexpand(true).hexpand(true).build();
+        let container = libadwaita::ViewStack::builder()
+            .vexpand(true)
+            .hexpand(true)
+            .build();
 
         let info_page = InformationPage::new();
 
-        container.add_titled_with_icon(&info_page.container, Some("info_page"), "Information", "info-symbolic");
+        container.add_titled_with_icon(
+            &info_page.container,
+            Some("info_page"),
+            "Information",
+            "info-symbolic",
+        );
 
         let oc_page = OcPage::new(&system_info);
 
-        container.add_titled_with_icon(&oc_page.container, Some("oc_page"), "Overclock", "power-profile-performance-symbolic");
+        container.add_titled_with_icon(
+            &oc_page.container,
+            Some("oc_page"),
+            "Overclock",
+            "power-profile-performance-symbolic",
+        );
 
         let thermals_page = ThermalsPage::new(root_win);
 
-        container.add_titled_with_icon(&thermals_page.container, Some("thermals_page"), "Thermals", "temperature-symbolic");
+        container.add_titled_with_icon(
+            &thermals_page.container,
+            Some("thermals_page"),
+            "Thermals",
+            "temperature-symbolic",
+        );
 
         let software_page = software_page(system_info, embedded_daemon);
-        container.add_titled_with_icon(&software_page, Some("software_page"), "Software", "preferences-other-symbolic");
+        container.add_titled_with_icon(
+            &software_page,
+            Some("software_page"),
+            "Software",
+            "preferences-other-symbolic",
+        );
 
         Self {
             container,
diff --git a/lact-gui/src/app/root_stack/thermals_page/mod.rs b/lact-gui/src/app/root_stack/thermals_page/mod.rs
index 5a9f4ce5..66198d9f 100644
--- a/lact-gui/src/app/root_stack/thermals_page/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/mod.rs
@@ -2,7 +2,7 @@ mod fan_curve_frame;
 
 use self::fan_curve_frame::FanCurveFrame;
 use super::{list_clamp, LabelRow};
-use crate::app::page_section::PageSection;
+use crate::{app::page_section::PageSection, info_dialog};
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
@@ -29,7 +29,7 @@ pub struct ThermalsPage {
 }
 
 impl ThermalsPage {
-    pub fn new(root_win: libadwaita::ApplicationWindow) -> Self {
+    pub fn new(root_win: &impl IsA<Window>) -> Self {
         let vbox = Box::builder()
             .orientation(Orientation::Vertical)
             .spacing(12)
@@ -96,11 +96,13 @@ impl ThermalsPage {
 
         vbox.append(&fan_control_section);
 
-        fan_control_mode_stack.connect_visible_child_name_notify(move |stack| {
-            if stack.visible_child_name() == Some("automatic".into()) {
-                show_fan_control_warning(&root_win)
-            }
-        });
+        fan_control_mode_stack.connect_visible_child_name_notify(
+            clone!(@strong root_win => move |stack| {
+                if stack.visible_child_name() == Some("automatic".into()) {
+                    show_fan_control_warning(&root_win)
+                }
+            }),
+        );
 
         let container = ScrolledWindow::builder()
             .hscrollbar_policy(PolicyType::Never)
@@ -256,13 +258,15 @@ fn static_speed_adj(parent_box: &Box) -> Adjustment {
     adjustment
 }
 
-fn show_fan_control_warning(root_win: &libadwaita::ApplicationWindow) {
-    let diag = libadwaita::MessageDialog::builder()
-        .heading("Warning")
-        .body("Due to a driver bug, a reboot may be required for fan control to properly switch back to automatic")
-        .modal(true)
-        .transient_for(root_win)
-        .build();
-    diag.add_response("ok", "_Ok");
-    diag.present();
+fn show_fan_control_warning(root_win: &impl IsA<Window>) {
+    info_dialog!(
+        root_win,
+        "Warning",
+        concat!(
+            "Due to a driver bug, a reboot may be required for fan control ",
+            "to properly switch back to automatic"
+        ),
+        "ok",
+        "_Ok"
+    );
 }

